﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;
namespace testProject.DataAccessLayer
{
    
    public class DALBase
    {
        public static string ReciveCardData = "";
        
        private string ConnectionString
        {
            get
            {

                //return @"Server=(local)\SqlServer2008;Database=ParkingDB;Integrated Security=True;";
                //return @"Server=delta\SqlServer2008;Database=ParkingDB;uid=sa;pwd=1;";
                //return "Data Source=(local)\\SQLEXPRESS;AttachDbFilename=|DataDirectory|\\ParkingDB.mdf;Integrated Security=True;Connect Timeout=30;User Instance=True";
                //return @"Server=(local)\SqlExpress;Database=ParkingDB;Integrated Security=True;";
                //return "Server="+Server()+ @";Database=ParkingDB;uid=sa;pwd=1;";
                //return @"Server=192.168.1.3\SqlServer2008;Database=ParkingDB;uid=sa;pwd=1;";
                return  Server();
            }
        }
        private string Server()
        {
            string str = "";
            str = Application.StartupPath.ToString() + "\\Server.txt";
            int counter = 0;
            string line;
            string strRes = "";
            // Read the file and display it line by line.
            System.IO.StreamReader file =               new System.IO.StreamReader( str );
            while ((line = file.ReadLine()) != null)
            {
              //  Console.WriteLine(line);
                strRes = line;
                counter++;

            }

            file.Close();

            // Suspend the screen.
            //Console.ReadLine();

            return strRes  ;
        }
        protected int ExecuteNoneQuery(CommandType commandType, string commandText, params SqlParameter[] commandParameters)
        {
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                SqlCommand cmd = new SqlCommand();
                cmd.Connection = con;
                cmd.CommandType = commandType;
                cmd.CommandText = commandText;
                if (commandParameters !=null ) cmd.Parameters.AddRange(commandParameters);
                con.Open();
                int retVal = cmd.ExecuteNonQuery();
                con.Close();
                return retVal;
            }
        }

        protected DataSet ExecuteDataset(CommandType commandType, string commandText, params SqlParameter[] commandParameters)
        {
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                SqlDataAdapter da = new SqlDataAdapter(commandText, con);
                DataSet ds = new DataSet();

                da.SelectCommand.CommandType = commandType;
                if (commandParameters != null)
                    da.SelectCommand.Parameters.AddRange(commandParameters);

                con.Open();
                da.Fill(ds);
                con.Close();

                return ds;

            }
        }

        protected DataTable ExecuteDataTable(CommandType commandType, string commandText, params SqlParameter[] commandParameters)
        {
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                SqlDataAdapter da = new SqlDataAdapter(commandText, con);
                DataTable dt = new DataTable();
                da.SelectCommand.CommandType = commandType;
                if (commandParameters != null)
                    da.SelectCommand.Parameters.AddRange(commandParameters);
                con.Open();
                da.Fill(dt);
                con.Close();

                return dt;

            }
        }

        protected SqlDataReader ExecuteReader(CommandType commandType, string commandText, params SqlParameter[] commandParameters)
        {
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                SqlCommand cmd = new SqlCommand();
                cmd.Connection = con;
                cmd.CommandType = commandType;
                cmd.CommandText = commandText;
                if (commandParameters != null)
                    cmd.Parameters.AddRange(commandParameters);
                con.Open();

                return cmd.ExecuteReader(CommandBehavior.CloseConnection);
            }
        }

        protected object ExecuteScaler(CommandType commandType, string commandText, params SqlParameter[] commandParameters)
        {

            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                SqlCommand cmd = new SqlCommand();
                cmd.Connection = con;
                cmd.CommandType = commandType;
                cmd.CommandText = commandText;

                if (commandParameters != null)
                    cmd.Parameters.AddRange(commandParameters);
                con.Open();

                Object reVal = cmd.ExecuteScalar();

                con.Close();

                return reVal;
            }
        }

    }

}