﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace testProject
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        DataTable dt;
        string[] columnName = new string[20];
        DataAccessLayer.Person ps3;

        private void button1_Click(object sender, EventArgs e)
        {
            frmUpdatePerson frm2 = new frmUpdatePerson();
            frm2.mid = Convert.ToInt32(dataGridView1["idMadrak", dataGridView1.CurrentRow.Index].Value);
            frm2.id = Convert.ToInt32(dataGridView1["idPerson", dataGridView1.CurrentRow.Index].Value);
            frm2.txtName.Text = (dataGridView1["Name", dataGridView1.CurrentRow.Index].Value).ToString();
            frm2.txtFamily.Text = (dataGridView1["Family", dataGridView1.CurrentRow.Index].Value).ToString();
            frm2.txtCode.Text = (dataGridView1["Code", dataGridView1.CurrentRow.Index].Value).ToString();
            frm2.txtBirthYear.Text = (dataGridView1["birthYear", dataGridView1.CurrentRow.Index].Value).ToString();
            frm2.ShowDialog();
            dt = ps3.selectAll();
            dataGridView1.DataSource = dt;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            frmNew f1 = new frmNew();
            f1.ShowDialog();
            dt = ps3.selectAll();
            dataGridView1.DataSource = dt;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                ps3 = new DataAccessLayer.Person();
                dt = ps3.selectAll();
                dataGridView1.DataSource = dt;
            }
            catch (Exception ex)
            {

                MessageBox.Show(ex.Message.ToString());
            }

            for(int i = 0;i<dt.Columns.Count;i++)
            {
                cmbSearch.Items.Add(dt.Columns[i].ColumnName);
            }
            cmbSearch.SelectedIndex = 0;

            columnName[0] = dt.Columns["Name"].ColumnName;
            columnName[1] = dt.Columns["Family"].ColumnName;
            columnName[2] = dt.Columns["idPerson"].ColumnName;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
               var res= MessageBox.Show("آيا مي خواهيد حذف كنيد؟","Delete",MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
               if (res == DialogResult.Yes)
               {
                   if (dt.Rows.Count != 0)
                   {
                       int id = Convert.ToInt32(dataGridView1["idPerson", dataGridView1.CurrentRow.Index].Value);
                       DataAccessLayer.Person ps1 = new DataAccessLayer.Person();
                       ps1.DeleteRow(id);
                       dt = ps3.selectAll();
                       dataGridView1.DataSource = dt;
                   }
               }
               else
               { }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
         
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            string str = cmbSearch.SelectedItem.ToString();
            if (textBox1.Text != "")
            {
                try
                {
                    dt.DefaultView.RowFilter = str + " = " + textBox1.Text;
                }
                catch (Exception)
                {
                    try
                    {
                        dt.DefaultView.RowFilter = str + " LIKE " + "'%" + textBox1.Text + "%'";
                    }
                    catch (Exception)
                    {
                        dt.DefaultView.RowFilter = str + "= null";
                    }
                }
            }
            else
            {
                dt = ps3.selectAll();
                dataGridView1.DataSource = dt;
            }
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            string items=string.Empty;

            if (textBox2.Text != "")
            {
                try
                {
                    int x = Convert.ToInt32(textBox2.Text);
                    items = string.Empty;
                    for (int i = 0; i < dt.Columns.Count; i++)
                    {
                        if (dt.Columns[i].DataType == typeof(Int32))
                        {
                            if (i == dt.Columns.Count - 1)
                            {
                                items += dt.Columns[i] + "=" + textBox2.Text;
                            }
                            else
                            {
                                items += dt.Columns[i] + "=" + textBox2.Text + " OR ";
                            }
                        }

                        else if (dt.Columns[i].DataType == typeof(string))
                        {
                            if (i == dt.Columns.Count - 1)
                            {
                                items += dt.Columns[i] + " LIKE '%" + textBox2.Text + "%'";
                            }
                            else
                            {
                                items += dt.Columns[i] + " LIKE '%" + textBox2.Text + "%'" + " OR ";
                            }
                        }
                    }

                }
                catch (Exception)
                {
                    try
                    {
                        items = string.Empty;
                        for (int i = 0; i < dt.Columns.Count; i++)
                        {
                            if (dt.Columns[i].DataType == typeof(string))
                            {
                                if (i == dt.Columns.Count)
                                {
                                    items += dt.Columns[i] + " LIKE '%" + textBox2.Text + "%'";
                                }
                                else
                                {
                                    items += dt.Columns[i] + " LIKE '%" + textBox2.Text + "%'" + " OR ";
                                }
                            }
                        }
                    }
                    catch (Exception)
                    {

                    }
                }
                if (items.Substring(items.Length - 3) == "OR ")
                {
                    items = items.Remove(items.Length - 3);
                }
                dt.DefaultView.RowFilter = items;
            }
            else
            {
                dt = ps3.selectAll();
                dataGridView1.DataSource = dt;
            }
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            Class.search srch = new Class.search();
            dt.DefaultView.RowFilter = srch.resaultOfSearch(dt, textBox3.Text);
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {
            Class.search1 srch1 = new Class.search1();
            dt.DefaultView.RowFilter = srch1.resaultOfSearch1(dt, textBox4.Text,columnName);
        }
    }
}
