﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
namespace testProject.DataAccessLayer
{
    public class Person:DALBase
    {
        public DataTable selectRowById(int id)
        {
            return ExecuteDataTable(CommandType.StoredProcedure, "selectById", new SqlParameter[]{
              new SqlParameter("@id",id)});
        }

        public int Insert(string Name, string Family, string Code, int birthYear, int idMadrak)
        {
            return ExecuteNoneQuery(CommandType.StoredProcedure, "insertPerson", new SqlParameter[]{
              new SqlParameter("@name",Name),
              new SqlParameter("@Family",Family),
              new SqlParameter("@code",Code),
              new SqlParameter("@birthday",birthYear),
              new SqlParameter("@idMadrak",idMadrak)});
        }
        public DataTable selectAll()
        {
            return ExecuteDataTable(CommandType.StoredProcedure, "SelectAll", null);
        }
        public int DeleteRow(int id)
        {
            return ExecuteNoneQuery(CommandType.StoredProcedure, "DeleteRow", new SqlParameter[]{
                new SqlParameter("@id",id)});
        }
        public int UpdatePerson(int id, string Name, string Family, string Code, int birthYear, int idMadrak)
        {
            return ExecuteNoneQuery(CommandType.StoredProcedure, "UpdatePerson", new SqlParameter[]{
              new SqlParameter("@idPerson",id),
              new SqlParameter("@Name",Name),
              new SqlParameter("@Family",Family),
              new SqlParameter("@Code",Code),
              new SqlParameter("@birthday",birthYear),
              new SqlParameter("@idMadrak",idMadrak)});
        }
    }
}
